Index: build/dnet-service-rmi-archetype/trunk/deploy.info
===================================================================
--- build/dnet-service-rmi-archetype/trunk/deploy.info	(revision 27226)
+++ build/dnet-service-rmi-archetype/trunk/deploy.info	(revision 27227)
@@ -1,10 +1,10 @@
 {
-	type_source: "SVN",
-	goal: "package -U -T 4C",
-	url: "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-service-rmi-archetype/trunk/",
-	deploy_repository: "dnet4-bootstrap-snapshot",
-	version: "4",
-	mail: "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
-	deploy_repository_url: "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
-	name: "dnet-service-rmi-archetype"
+	"type_source": "SVN",
+	"goal": "package -U -T 4C",
+	"url": "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-service-rmi-archetype/trunk/",
+	"deploy_repository": "dnet4-bootstrap-snapshot",
+	"version": "4",
+	"mail": "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
+	"deploy_repository_url": "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
+	"name": "dnet-service-rmi-archetype"
 }
\ No newline at end of file
Index: build/dnet-archetype/trunk/deploy.info
===================================================================
--- build/dnet-archetype/trunk/deploy.info	(revision 27226)
+++ build/dnet-archetype/trunk/deploy.info	(revision 27227)
@@ -1,10 +1,10 @@
 {
-	type_source: "SVN",
-	goal: "package -U -T 4C",
-	url: "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-archetype/trunk/",
-	deploy_repository: "dnet4-bootstrap-snapshot",
-	version: "4",
-	mail: "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
-	deploy_repository_url: "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
-	name: "dnet-archetype"
+	"type_source": "SVN",
+	"goal": "package -U -T 4C",
+	"url": "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-archetype/trunk/",
+	"deploy_repository": "dnet4-bootstrap-snapshot",
+	"version": "4",
+	"mail": "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
+	"deploy_repository_url": "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
+	"name": "dnet-archetype"
 }
\ No newline at end of file
Index: build/dnet-container-archetype/trunk/deploy.info
===================================================================
--- build/dnet-container-archetype/trunk/deploy.info	(revision 27226)
+++ build/dnet-container-archetype/trunk/deploy.info	(revision 27227)
@@ -1,10 +1,10 @@
 {
-	type_source: "SVN",
-	goal: "package -U -T 4C",
-	url: "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-container-archetype/trunk/",
-	deploy_repository: "dnet4-bootstrap-snapshot",
-	version: "4",
-	mail: "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
-	deploy_repository_url: "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
-	name: "dnet-container-archetype"
+	"type_source": "SVN",
+	"goal": "package -U -T 4C",
+	"url": "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-container-archetype/trunk/",
+	"deploy_repository": "dnet4-bootstrap-snapshot",
+	"version": "4",
+	"mail": "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
+	"deploy_repository_url": "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
+	"name": "dnet-container-archetype"
 }
\ No newline at end of file
Index: build/dnet-service-implementation-archetype/trunk/deploy.info
===================================================================
--- build/dnet-service-implementation-archetype/trunk/deploy.info	(revision 27226)
+++ build/dnet-service-implementation-archetype/trunk/deploy.info	(revision 27227)
@@ -1,10 +1,10 @@
 {
-	type_source: "SVN",
-	goal: "package -U -T 4C",
-	url: "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-service-implementation-archetype/trunk/",
-	deploy_repository: "dnet4-bootstrap-snapshot",
-	version: "4",
-	mail: "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
-	deploy_repository_url: "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
-	name: "dnet-service-implementation-archetype"
+	"type_source": "SVN",
+	"goal": "package -U -T 4C",
+	"url": "http://svn-public.driver.research-infrastructures.eu/driver/dnet40/build/dnet-service-implementation-archetype/trunk/",
+	"deploy_repository": "dnet4-bootstrap-snapshot",
+	"version": "4",
+	"mail": "sandro.labruzzo@isti.cnr.it,michele.artini@isti.cnr.it, claudio.atzori@isti.cnr.it, alessia.bardi@isti.cnr.it",
+	"deploy_repository_url": "http://maven.research-infrastructures.eu/nexus/content/repositories/dnet4-bootstrap-snapshot",
+	"name": "dnet-service-implementation-archetype"
 }
\ No newline at end of file