Index: modules/icm-iis-parent-container/trunk/pom.xml
===================================================================
--- modules/icm-iis-parent-container/trunk/pom.xml	(revision 36436)
+++ modules/icm-iis-parent-container/trunk/pom.xml	(revision 36437)
@@ -27,6 +27,7 @@
         <!-- notice: sandboxName is generated based on workflow.source.dir property -->
         <workflow.source.dir>src/test/resources/define/path/pointing/to/directory/holding/oozie_app</workflow.source.dir>
         <iis.hadoop.frontend.user.name>${user.name}</iis.hadoop.frontend.user.name>
+        <iis.hadoop.frontend.user.dir>${iis.hadoop.frontend.user.name}</iis.hadoop.frontend.user.dir>
         <iis.hadoop.frontend.home.dir>/mnt/tmp</iis.hadoop.frontend.home.dir>
         <iis.hadoop.master.host.name>localhost</iis.hadoop.master.host.name>
         <iis.hadoop.frontend.host.name>localhost</iis.hadoop.frontend.host.name>
@@ -386,7 +387,7 @@
 								<argument>${iis.hadoop.frontend.user.name}@${iis.hadoop.frontend.host.name}</argument>
 								<argument>-p ${iis.hadoop.frontend.port.ssh}</argument>
 								<argument>-o StrictHostKeyChecking=no</argument>
-								<argument>rm -rf ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.name}/oozie-packages/${sandboxName}/${output.dir.name}/; mkdir -p ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.name}/oozie-packages/${sandboxName}/${output.dir.name}/</argument>
+								<argument>rm -rf ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.dir}/oozie-packages/${sandboxName}/${output.dir.name}/; mkdir -p ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.dir}/oozie-packages/${sandboxName}/${output.dir.name}/</argument>
 						    </arguments>
 				          </configuration>
 				        </execution>
@@ -402,7 +403,7 @@
 						    	<argument>-P ${iis.hadoop.frontend.port.ssh}</argument>
 						    	<argument>-o StrictHostKeyChecking=no</argument>
 								<argument>target/${oozie.package.file.name}.tar.gz</argument>
-								<argument>${iis.hadoop.frontend.user.name}@${iis.hadoop.frontend.host.name}:${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.name}/oozie-packages/${sandboxName}/${output.dir.name}/${oozie.package.file.name}.tar.gz</argument>
+								<argument>${iis.hadoop.frontend.user.name}@${iis.hadoop.frontend.host.name}:${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.dir}/oozie-packages/${sandboxName}/${output.dir.name}/${oozie.package.file.name}.tar.gz</argument>
 						    </arguments>
 				          </configuration>
 				        </execution>
@@ -419,9 +420,9 @@
 								<argument>${iis.hadoop.frontend.user.name}@${iis.hadoop.frontend.host.name}</argument>
 								<argument>-p ${iis.hadoop.frontend.port.ssh}</argument>
 								<argument>-o StrictHostKeyChecking=no</argument>
-								<argument>cd ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.name}/oozie-packages/${sandboxName}/${output.dir.name}/; </argument>
+								<argument>cd ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.dir}/oozie-packages/${sandboxName}/${output.dir.name}/; </argument>
 								<argument>tar -zxvf oozie-package.tar.gz; </argument>
-								<argument>rm ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.name}/oozie-packages/${sandboxName}/${output.dir.name}/oozie-package.tar.gz; </argument>
+								<argument>rm ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.dir}/oozie-packages/${sandboxName}/${output.dir.name}/oozie-package.tar.gz; </argument>
 								<argument>./upload_workflow.sh</argument> 
 						    </arguments>
 						  </configuration>
@@ -455,7 +456,7 @@
 								<argument>${iis.hadoop.frontend.user.name}@${iis.hadoop.frontend.host.name}</argument>
 								<argument>-p ${iis.hadoop.frontend.port.ssh}</argument>
 								<argument>-o StrictHostKeyChecking=no</argument>
-								<argument>cd ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.name}/oozie-packages/${sandboxName}/${output.dir.name}/; </argument>
+								<argument>cd ${iis.hadoop.frontend.home.dir}/${iis.hadoop.frontend.user.dir}/oozie-packages/${sandboxName}/${output.dir.name}/; </argument>
 								<argument>./run_workflow.sh</argument>
 						    </arguments>
 						  </configuration>